<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { init } from 'aos';
import SlpContainer from '../../components/common/container.vue';
import SlpColumn from '../../components/common/column.vue';
import SolutionsCallToAction from '../../components/common/cta.vue';
import CopyMedia from '../../components/common/copy-media.vue';
import Copy from '../../components/common/copy.vue';
import SolutionsFeaturedMedia from '~/components/solutions/featured-media.vue';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    Copy,
    CopyMedia,
    SolutionsFeaturedMedia,
    SlpContainer,
    SlpColumn,
    SolutionsCallToAction,
  },
  layout: 'minimized-footer',
  // eslint-disable-next-line
  async asyncData({ $content, params, error }: any) {
    try {
      const solution = await $content(`solutions/index`).fetch();
      return { solution };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).solution, this.$route.path);
  },
  beforeMount() {
    init({
      once: true,
    });
  },
});
</script>

<template>
  <SlpContainer class="container__solutions">
    <SlpColumn :cols="10">
      <component
        :is="component.name"
        v-for="component in solution.components"
        :key="component.name"
        :data="component.data"
      />
    </SlpColumn>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.container__solutions {
  display: flex;
  flex-direction: column;
  align-items: center;
}
</style>
